Index: i386/i386/mp_machdep.c
===========================================================================
--- sys/i386/i386/mp_machdep.c	2003/10/30 14:48:07	#60
+++ i386/i386/mp_machdep.c	2003/10/30 14:48:07
@@ -2084,18 +598,23 @@
 	/* set up temporary P==V mapping for AP boot */
 	/* XXX this is a hack, we should boot the AP on its own stack/PTD */
 	kptbase = (uintptr_t)(void *)KPTphys;
-	for (x = 0; x < NKPT; x++)
-		PTD[x] = (pd_entry_t)(PG_V | PG_RW |
-		    ((kptbase + x * PAGE_SIZE) & PG_FRAME));
+	for (i = 0; i < NKPT; i++)
+		PTD[i] = (pd_entry_t)(PG_V | PG_RW |
+		    ((kptbase + i * PAGE_SIZE) & PG_FRAME));
 	invltlb();
 
 	/* start each AP */
-	for (x = 1; x <= mp_naps; ++x) {
+	for (cpu = 0, apic_id = 0; apic_id < MAXCPU; apic_id++) {
+		if (!cpu_info[apic_id].cpu_present ||
+		    cpu_info[apic_id].cpu_bsp)
+			continue;
+		cpu++;
 
-		/* This is a bit verbose, it will go away soon.  */
+		/* save APIC ID for this logical ID */
+		cpu_apic_ids[cpu] = apic_id;
 
 		/* first page of AP's private space */
-		pg = x * i386_btop(sizeof(struct privatespace));
+		pg = cpu * i386_btop(sizeof(struct privatespace));
 
 		/* allocate a new private data page */
 		pc = (struct pcpu *)kmem_alloc(kernel_map, PAGE_SIZE);
@@ -2110,7 +629,8 @@
 			    (PG_V | PG_RW | vtophys(PAGE_SIZE * i + stack));
 
 		/* prime data page for it to use */
-		pcpu_init(pc, x, sizeof(struct pcpu));
+		pcpu_init(pc, cpu, sizeof(struct pcpu));
+		pc->pc_apic_id = apic_id;
 
 		/* setup a vector to our boot code */
 		*((volatile u_short *) WARMBOOT_OFF) = WARMBOOT_TARGET;
@@ -2120,13 +640,14 @@
 		outb(CMOS_DATA, BIOS_WARM);	/* 'warm-start' */
 #endif
 
-		bootSTK = &SMP_prvspace[x].idlekstack[KSTACK_PAGES * PAGE_SIZE];
-		bootAP = x;
+		bootSTK = &SMP_prvspace[cpu].idlekstack[KSTACK_PAGES *
+		    PAGE_SIZE];
+		bootAP = cpu;
 
 		/* attempt to start the Application Processor */
 		CHECK_INIT(99);	/* setup checkpoints */
-		if (!start_ap(x, boot_addr)) {
-			printf("AP #%d (PHY# %d) failed!\n", x, CPU_TO_ID(x));
+		if (!start_ap(apic_id, boot_addr)) {
+			printf("AP #%d (PHY# %d) failed!\n", cpu, apic_id);
 			CHECK_PRINT("trace");	/* show checkpoints */
 			/* better panic as the AP may be running loose */
 			printf("panic y/n? [y] ");
@@ -2135,18 +656,12 @@
 		}
 		CHECK_PRINT("trace");		/* show checkpoints */
 
-		/* record its version info */
-		cpu_apic_versions[x] = cpu_apic_versions[0];
-
-		all_cpus |= (1 << x);		/* record AP in CPU map */
+		all_cpus |= (1 << cpu);		/* record AP in CPU map */
 	}
 
 	/* build our map of 'other' CPUs */
 	PCPU_SET(other_cpus, all_cpus & ~PCPU_GET(cpumask));
 
-	/* fill in our (BSP) APIC version */
-	cpu_apic_versions[0] = lapic.version;
-
 	/* restore the warmstart vector */
 	*(u_long *) WARMBOOT_OFF = mpbioswarmvec;
 #ifndef PC98
@@ -2167,11 +682,12 @@
 		SMPpt[1 + i] = (pt_entry_t)
 		    (PG_V | PG_RW | vtophys(PAGE_SIZE * i + stack));
 
-	for (x = 0; x < NKPT; x++)
-		PTD[x] = 0;
+	for (i = 0; i < NKPT; i++)
+		PTD[i] = 0;
+	pmap_invalidate_range(kernel_pmap, 0, NKPT * NBPDR - 1);
 
 	/* number of APs actually started */
-	return mp_ncpus - 1;
+	return mp_naps;
 }
 
 /*
@@ -2200,6 +716,7 @@
 
 	POSTCODE(INSTALL_AP_TRAMP_POST);
 
+	pmap_kenter(boot_addr + KERNBASE, boot_addr);
 	for (x = 0; x < size; ++x)
 		*dst++ = *src++;
 
@@ -2241,23 +758,18 @@
  * but it seems to work.
  */
 static int
-start_ap(int logical_cpu, u_int boot_addr)
+start_ap(int apic_id, u_int boot_addr)
 {
-	int     physical_cpu;
-	int     vector;
-	int     cpus;
-	u_long  icr_lo, icr_hi;
+	int vector, ms;
+	int cpus;
 
 	POSTCODE(START_AP_POST);
 
-	/* get the PHYSICAL APIC ID# */
-	physical_cpu = CPU_TO_ID(logical_cpu);
-
 	/* calculate the vector */
 	vector = (boot_addr >> 12) & 0xff;
 
 	/* used as a watchpoint to signal AP startup */
-	cpus = mp_ncpus;
+	cpus = mp_naps;
 
 	/*
 	 * first we do an INIT/RESET IPI this INIT IPI might be run, reseting
@@ -2266,31 +778,20 @@
 	 * ignored.
 	 */
 
-	/* setup the address for the target AP */
-	icr_hi = lapic.icr_hi & ~APIC_ID_MASK;
-	icr_hi |= (physical_cpu << 24);
-	lapic.icr_hi = icr_hi;
-
-	/* setup common fields for subsequent IPIs */
-	icr_lo = lapic.icr_lo & APIC_ICRLO_RESV_MASK;
-	icr_lo |= APIC_DESTMODE_PHY;
-
 	/* do an INIT IPI: assert RESET */
-	lapic.icr_lo = icr_lo | APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
-	    APIC_LEVEL_ASSERT | APIC_DELMODE_INIT;
+	lapic_ipi_raw(APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
+	    APIC_LEVEL_ASSERT | APIC_DESTMODE_PHY | APIC_DELMODE_INIT, apic_id);
 
 	/* wait for pending status end */
-	while (lapic.icr_lo & APIC_DELSTAT_MASK)
-		 /* spin */ ;
+	lapic_ipi_wait(-1);
 
 	/* do an INIT IPI: deassert RESET */
-	lapic.icr_lo = icr_lo | APIC_DEST_ALLESELF | APIC_TRIGMOD_LEVEL |
-	    APIC_LEVEL_DEASSERT | APIC_DELMODE_INIT;
+	lapic_ipi_raw(APIC_DEST_ALLESELF | APIC_TRIGMOD_LEVEL |
+	    APIC_LEVEL_DEASSERT | APIC_DESTMODE_PHY | APIC_DELMODE_INIT, 0);
 
 	/* wait for pending status end */
-	u_sleep(10000);		/* wait ~10mS */
-	while (lapic.icr_lo & APIC_DELSTAT_MASK)
-		 /* spin */ ;
+	DELAY(10000);		/* wait ~10mS */
+	lapic_ipi_wait(-1);
 
 	/*
 	 * next we do a STARTUP IPI: the previous INIT IPI might still be
@@ -2302,11 +803,11 @@
 	 */
 
 	/* do a STARTUP IPI */
-	lapic.icr_lo = icr_lo | APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
-	    APIC_LEVEL_DEASSERT | APIC_DELMODE_STARTUP | vector;
-	while (lapic.icr_lo & APIC_DELSTAT_MASK)
-		 /* spin */ ;
-	u_sleep(200);		/* wait ~200uS */
+	lapic_ipi_raw(APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
+	    APIC_LEVEL_DEASSERT | APIC_DESTMODE_PHY | APIC_DELMODE_STARTUP |
+	    vector, apic_id);
+	lapic_ipi_wait(-1);
+	DELAY(200);		/* wait ~200uS */
 
 	/*
 	 * finally we do a 2nd STARTUP IPI: this 2nd STARTUP IPI should run IF
@@ -2315,23 +816,21 @@
 	 * recognized after hardware RESET or INIT IPI.
 	 */
 
-	lapic.icr_lo = icr_lo | APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
-	    APIC_LEVEL_DEASSERT | APIC_DELMODE_STARTUP | vector;
-	while (lapic.icr_lo & APIC_DELSTAT_MASK)
-		 /* spin */ ;
-	u_sleep(200);		/* wait ~200uS */
+	lapic_ipi_raw(APIC_DEST_DESTFLD | APIC_TRIGMOD_EDGE |
+	    APIC_LEVEL_DEASSERT | APIC_DESTMODE_PHY | APIC_DELMODE_STARTUP |
+	    vector, apic_id);
+	lapic_ipi_wait(-1);
+	DELAY(200);		/* wait ~200uS */
 
-	/* wait for it to start */
-	set_apic_timer(5000000);/* == 5 seconds */
-	while (read_apic_timer())
-		if (mp_ncpus > cpus)
+	/* Wait up to 5 seconds for it to start. */
+	for (ms = 0; ms < 5000; ms++) {
+		if (mp_naps > cpus)
 			return 1;	/* return SUCCESS */
-
+		DELAY(1000);
+	}
 	return 0;		/* return FAILURE */
 }
 
-#if defined(APIC_IO)
-
 #ifdef COUNT_XINVLTLB_HITS
 u_int xhits_gbl[MAXCPU];
 u_int xhits_pg[MAXCPU];
@@ -2366,7 +865,7 @@
     &ipi_masked_range, 0, "");
 SYSCTL_INT(_debug_xhits, OID_AUTO, ipi_masked_range_size, CTLFLAG_RW,
     &ipi_masked_range_size, 0, "");
-#endif
+#endif /* COUNT_XINVLTLB_HITS */
 
 /*
  * Flush the TLB on all other CPU's
@@ -2375,22 +874,17 @@
 smp_tlb_shootdown(u_int vector, vm_offset_t addr1, vm_offset_t addr2)
 {
 	u_int ncpu;
-	register_t eflags;
 
 	ncpu = mp_ncpus - 1;	/* does not shootdown self */
 	if (ncpu < 1)
 		return;		/* no other cpus */
-	eflags = read_eflags();
-	if ((eflags & PSL_I) == 0)
-		panic("absolutely cannot call smp_ipi_shootdown with interrupts already disabled");
-	mtx_lock_spin(&smp_tlb_mtx);
+	mtx_assert(&smp_tlb_mtx, MA_OWNED);
 	smp_tlb_addr1 = addr1;
 	smp_tlb_addr2 = addr2;
 	atomic_store_rel_int(&smp_tlb_wait, 0);
 	ipi_all_but_self(vector);
 	while (smp_tlb_wait < ncpu)
 		ia32_pause();
-	mtx_unlock_spin(&smp_tlb_mtx);
 }
 
 /*
@@ -2443,7 +937,6 @@
 smp_targeted_tlb_shootdown(u_int mask, u_int vector, vm_offset_t addr1, vm_offset_t addr2)
 {
 	int ncpu, othercpus;
-	register_t eflags;
 
 	othercpus = mp_ncpus - 1;
 	if (mask == (u_int)-1) {
@@ -2465,10 +958,7 @@
 		if (ncpu < 1)
 			return;
 	}
-	eflags = read_eflags();
-	if ((eflags & PSL_I) == 0)
-		panic("absolutely cannot call smp_targeted_ipi_shootdown with interrupts already disabled");
-	mtx_lock_spin(&smp_tlb_mtx);
+	mtx_assert(&smp_tlb_mtx, MA_OWNED);
 	smp_tlb_addr1 = addr1;
 	smp_tlb_addr2 = addr2;
 	atomic_store_rel_int(&smp_tlb_wait, 0);
@@ -2478,40 +968,33 @@
 		ipi_selected(mask, vector);
 	while (smp_tlb_wait < ncpu)
 		ia32_pause();
-	mtx_unlock_spin(&smp_tlb_mtx);
 }
-#endif
 
 void
 smp_invltlb(void)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_tlb_shootdown(IPI_INVLTLB, 0, 0);
 #ifdef COUNT_XINVLTLB_HITS
 		ipi_global++;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 void
 smp_invlpg(vm_offset_t addr)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_tlb_shootdown(IPI_INVLPG, addr, 0);
 #ifdef COUNT_XINVLTLB_HITS
 		ipi_page++;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 void
 smp_invlpg_range(vm_offset_t addr1, vm_offset_t addr2)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_tlb_shootdown(IPI_INVLRNG, addr1, addr2);
 #ifdef COUNT_XINVLTLB_HITS
@@ -2519,39 +1002,33 @@
 		ipi_range_size += (addr2 - addr1) / PAGE_SIZE;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 void
 smp_masked_invltlb(u_int mask)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_targeted_tlb_shootdown(mask, IPI_INVLTLB, 0, 0);
 #ifdef COUNT_XINVLTLB_HITS
 		ipi_masked_global++;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 void
 smp_masked_invlpg(u_int mask, vm_offset_t addr)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_targeted_tlb_shootdown(mask, IPI_INVLPG, addr, 0);
 #ifdef COUNT_XINVLTLB_HITS
 		ipi_masked_page++;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 void
 smp_masked_invlpg_range(u_int mask, vm_offset_t addr1, vm_offset_t addr2)
 {
-#if defined(APIC_IO)
 	if (smp_started) {
 		smp_targeted_tlb_shootdown(mask, IPI_INVLRNG, addr1, addr2);
 #ifdef COUNT_XINVLTLB_HITS
@@ -2559,101 +1036,18 @@
 		ipi_masked_range_size += (addr2 - addr1) / PAGE_SIZE;
 #endif
 	}
-#endif  /* APIC_IO */
 }
 
 
 /*
- * This is called once the rest of the system is up and running and we're
- * ready to let the AP's out of the pen.
- */
-void
-ap_init(void)
-{
-	u_int	apic_id;
-
-	/* spin until all the AP's are ready */
-	while (!aps_ready)
-		ia32_pause();
-
-	/* BSP may have changed PTD while we were waiting */
-	invltlb();
-
-#if defined(I586_CPU) && !defined(NO_F00F_HACK)
-	lidt(&r_idt);
-#endif
-
-	/* set up CPU registers and state */
-	cpu_setregs();
-
-	/* set up FPU state on the AP */
-	npxinit(__INITIAL_NPXCW__);
-
-	/* set up SSE registers */
-	enable_sse();
-
-	/* A quick check from sanity claus */
-	apic_id = (apic_id_to_logical[(lapic.id & 0x0f000000) >> 24]);
-	if (PCPU_GET(cpuid) != apic_id) {
-		printf("SMP: cpuid = %d\n", PCPU_GET(cpuid));
-		printf("SMP: apic_id = %d\n", apic_id);
-		printf("PTD[MPPTDI] = %#jx\n", (uintmax_t)PTD[MPPTDI]);
-		panic("cpuid mismatch! boom!!");
-	}
-
-	/* Init local apic for irq's */
-	apic_initialize();
-
-	/* Set memory range attributes for this CPU to match the BSP */
-	mem_range_AP_init();
-
-	mtx_lock_spin(&ap_boot_mtx);
-
-	smp_cpus++;
-
-	CTR1(KTR_SMP, "SMP: AP CPU #%d Launched", PCPU_GET(cpuid));
-	printf("SMP: AP CPU #%d Launched!\n", PCPU_GET(cpuid));
-
-	/* Build our map of 'other' CPUs. */
-	PCPU_SET(other_cpus, all_cpus & ~PCPU_GET(cpumask));
-
-	if (bootverbose)
-		apic_dump("ap_init()");
-
-	if (smp_cpus == mp_ncpus) {
-		/* enable IPI's, tlb shootdown, freezes etc */
-		atomic_store_rel_int(&smp_started, 1);
-		smp_active = 1;	 /* historic */
-	}
-
-	mtx_unlock_spin(&ap_boot_mtx);
-
-	/* wait until all the AP's are up */
-	while (smp_started == 0)
-		ia32_pause();
-
-	/* ok, now grab sched_lock and enter the scheduler */
-	mtx_lock_spin(&sched_lock);
-
-	binuptime(PCPU_PTR(switchtime));
-	PCPU_SET(switchticks, ticks);
-
-	cpu_throw(NULL, choosethread());	/* doesn't return */
-
-	panic("scheduler returned us to %s", __func__);
-}
-
-/*
  * For statclock, we send an IPI to all CPU's to have them call this
  * function.
- *
- * WARNING! unpend() will call statclock() directly and skip this
- * routine.
  */
 void
 forwarded_statclock(struct clockframe frame)
 {
 
+	CTR0(KTR_SMP, "forwarded_statclock");
 	if (profprocs != 0)
 		profclock(&frame);
 	if (pscnt == psdiv)
@@ -2681,14 +1075,12 @@
  * sched_lock if we could simply peek at the CPU to determine the user/kernel
  * state and call hardclock_process() on the CPU receiving the clock interrupt
  * and then just use a simple IPI to handle any ast's if needed.
- *
- * WARNING! unpend() will call hardclock_process() directly and skip this
- * routine.
  */
 void
 forwarded_hardclock(struct clockframe frame)
 {
 
+	CTR0(KTR_SMP, "forwarded_hardclock");
 	hardclock_process(&frame);
 }
 
@@ -2707,31 +1099,22 @@
 		ipi_selected(map, IPI_HARDCLOCK);
 }
 
-#ifdef APIC_INTR_REORDER
-/*
- *	Maintain mapping from softintr vector to isr bit in local apic.
- */
-void
-set_lapic_isrloc(int intr, int vector)
-{
-	if (intr < 0 || intr > 32)
-		panic("set_apic_isrloc: bad intr argument: %d",intr);
-	if (vector < ICU_OFFSET || vector > 255)
-		panic("set_apic_isrloc: bad vector argument: %d",vector);
-	apic_isrbit_location[intr].location = &lapic.isr0 + ((vector>>5)<<2);
-	apic_isrbit_location[intr].bit = (1<<(vector & 31));
-}
-#endif
-
 /*
  * send an IPI to a set of cpus.
  */
 void
 ipi_selected(u_int32_t cpus, u_int ipi)
 {
+	int cpu;
 
 	CTR3(KTR_SMP, "%s: cpus: %x ipi: %x", __func__, cpus, ipi);
-	selected_apic_ipi(cpus, ipi, APIC_DELMODE_FIXED);
+	while ((cpu = ffs(cpus)) != 0) {
+		cpu--;
+		KASSERT(cpu_apic_ids[cpu] != -1,
+		    ("IPI to non-existent CPU %d", cpu));
+		lapic_ipi_vectored(ipi, cpu_apic_ids[cpu]);
+		cpus &= ~(1 << cpu);
+	}
 }
 
 /*
@@ -2742,7 +1125,7 @@
 {
 
 	CTR2(KTR_SMP, "%s: ipi: %x", __func__, ipi);
-	apic_ipi(APIC_DEST_ALLISELF, ipi, APIC_DELMODE_FIXED); 
+	lapic_ipi_vectored(ipi, APIC_IPI_DEST_ALL);
 }
 
 /*
@@ -2753,7 +1136,7 @@
 {
 
 	CTR2(KTR_SMP, "%s: ipi: %x", __func__, ipi);
-	apic_ipi(APIC_DEST_ALLESELF, ipi, APIC_DELMODE_FIXED); 
+	lapic_ipi_vectored(ipi, APIC_IPI_DEST_OTHERS);
 }
 
 /*
@@ -2764,9 +1147,13 @@
 {
 
 	CTR2(KTR_SMP, "%s: ipi: %x", __func__, ipi);
-	apic_ipi(APIC_DEST_SELF, ipi, APIC_DELMODE_FIXED); 
+	lapic_ipi_vectored(ipi, APIC_IPI_DEST_SELF);
 }
 
+/*
+ * This is called once the rest of the system is up and running and we're
+ * ready to let the AP's out of the pen.
+ */
 static void
 release_aps(void *dummy __unused)
 {
Index: i386/i386/mpboot.s
===========================================================================
--- sys/i386/i386/mpboot.s	2003/10/30 14:48:07	#4
+++ i386/i386/mpboot.s	2003/10/30 14:48:07
@@ -37,7 +37,7 @@
 #include "opt_pmap.h"
 
 #include <machine/asmacros.h>		/* miscellaneous asm macros */
-#include <machine/apic.h>
+#include <machine/apicreg.h>
 #include <machine/specialreg.h>
 
 #include "assym.s"
@@ -77,6 +77,32 @@
 
 NON_GPROF_ENTRY(MPentry)
 	CHECKPOINT(0x36, 3)
+	/*
+	 * Enable features on this processor.  We don't support SMP on
+	 * CPUs older than a Pentium, so we know that we can use the cpuid
+	 * instruction.
+	 */
+	movl	$1,%eax
+	cpuid					/* Retrieve features */
+	movl	%cr4,%eax
+#ifndef DISABLE_PSE
+	testl	$CPUID_PSE,%edx
+	jz 1f
+	orl	$CR4_PSE,%eax			/* Enable PSE  */
+1:
+#endif
+#ifndef DISABLE_PG_G
+	testl	$CPUID_PGE,%edx
+	jz 1f
+	orl	$CR4_PGE,%eax			/* Enable PGE  */
+1:	
+#endif
+	testl	$CPUID_VME,%edx
+	jz 1f
+	orl	$CR4_VME,%eax			/* Enable VME  */
+1:
+	movl	%eax,%cr4
+
 	/* Now enable paging mode */
 #ifdef PAE
 	movl	R(IdlePDPT), %eax
@@ -88,22 +114,6 @@
 	movl	R(IdlePTD), %eax
 	movl	%eax,%cr3	
 #endif
-#ifndef DISABLE_PSE
-	cmpl	$0, R(pseflag)
-	je	1f
-	movl	%cr4, %eax
-	orl	$CR4_PSE, %eax
-	movl	%eax, %cr4
-1:
-#endif
-#ifndef DISABLE_PG_G
-	cmpl	$0, R(pgeflag)
-	je	2f
-	movl	%cr4, %eax
-	orl	$CR4_PGE, %eax
-	movl	%eax, %cr4
-2:
-#endif
 	movl	%cr0,%eax
 	orl	$CR0_PE|CR0_PG,%eax		/* enable paging */
 	movl	%eax,%cr0			/* let the games begin! */
@@ -118,32 +128,6 @@
 mp_begin:	/* now running relocated at KERNBASE */
 	CHECKPOINT(0x37, 4)
 	call	init_secondary			/* load i386 tables */
-	CHECKPOINT(0x38, 5)
-
-	/*
-	 * If the [BSP] CPU has support for VME, turn it on.
-	 */
-	testl	$CPUID_VME, cpu_feature		/* XXX WRONG! BSP! */
-	jz	1f
-	movl	%cr4, %eax
-	orl	$CR4_VME, %eax
-	movl	%eax, %cr4
-1:
-
-	/* disable the APIC, just to be SURE */
-	movl	lapic+LA_SVR, %eax		/* get spurious vector reg. */
-	andl	$~APIC_SVR_SWEN, %eax		/* clear software enable bit */
-	movl	%eax, lapic+LA_SVR
-
-	/* signal our startup to the BSP */
-	movl	lapic+LA_VER, %eax		/* our version reg contents */
-	movl	%eax, cpu_apic_versions		/* into [ 0 ] */
-	incl	mp_ncpus			/* signal BSP */
-
-	CHECKPOINT(0x39, 6)
-
-	/* Now, let's prepare for some REAL WORK :-)  This doesn't return. */
-	call	ap_init
 
 /*
  * This is the embedded trampoline or bootstrap that is
